my %track;
my %queuechan;
my %membername;
my %callunique;
my %connectqueue;
my %ishold;

$AMI_Event_Handler{'holdreport'}{'UNHOLD'} = sub {
    my $event = shift;
    my @allreturn;

    my $status       = 'Off';
    my $channel      = ${$event}{'Channel'};
    my $uniq         = ${$event}{'Uniqueid'};

    #print "Hold $status chan $channel uniq $uniq\n";

    my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
    my $event = "PAUSE";

    if(defined($queuechan{$canal})) {

        $event = "UNPAUSE";
        $ishold{$canal} = 0;

        my $name  = $membername{$queuechan{$canal}};
        my $uniq  = $callunique{$queuechan{$canal}};
        my $queue = $connectqueue{$queuechan{$canal}};

        $return  = "Action: QueueLog\r\n";
        $return .= "Queue: $queue\r\n";
        $return .= "Event: $event\r\n";
        $return .= "Uniqueid: $uniq\r\n";
        $return .= "Message: Hold\r\n";
        $return .= "Interface: $name\r\n\r\n";
        push @allreturn, $return;

    } 
    return @allreturn;

};

$AMI_Event_Handler{'holdreport'}{'HOLD'} = sub {
    my $event = shift;
    my @allreturn;

    my $status       = defined(${$event}{'Status'})?${$event}{'Status'}:'On';  # On or Off, asterisk 13 does not set status but has unhold event
    my $channel      = ${$event}{'Channel'};
    my $uniq         = ${$event}{'Uniqueid'};

    my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
    my $event = "PAUSE";

    if(defined($queuechan{$canal})) {

        if($status eq "On") {
          $event ="PAUSE";
          $ishold{$canal}=1;
        } else {
          $event ="UNPAUSE";
          $ishold{$canal}=0;
        }

        my $name = $membername{$queuechan{$canal}};
        my $uniq = $callunique{$queuechan{$canal}};
        my $queue = $connectqueue{$queuechan{$canal}};

        if($ishold{$canal}==1) {

            $return  = "Action: QueueLog\r\n";
            $return .= "Queue: $queue\r\n";
            $return .= "Event: $event\r\n";
            $return .= "Uniqueid: $uniq\r\n";
            $return .= "Message: Hold\r\n";
            $return .= "Interface: $name\r\n\r\n";
            push @allreturn, $return;
 
        }

    } 
    return @allreturn;
};

$AMI_Event_Handler{'holdreport'}{'AGENTCALLED'} = sub {
    my $event = shift;
    my @allreturn;
    my $chan = '';

    if(defined(${$event}{'DestChannel'})) {
        $chan = ${$event}{'DestChannel'};
    } else {
        $chan = ${$event}{'DestinationChannel'};
    }

    if ( $chan =~ /^Local/ ) {
        # Track local agents to find real channel in DIAL event below 
        my $canal = FOP2::utils::get_channel($chan);
        $track{$canal}=1; 
    } 
    return @allreturn;
};

$AMI_Event_Handler{'holdreport'}{'DIALBEGIN'} = sub {
    my $event = shift;
    my @allreturn;

    my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
    my $desti = '';
    my $chan = '';

    if(defined($track{$canal})) {
        if(defined(${$event}{'DestChannel'})) {
            $chan = ${$event}{'DestChannel'}
        } else {
            $chan = ${$event}{'Destination'}
        }
        $desti = FOP2::utils::get_channel($chan);
        $queuechan{$desti}=$canal;
    }
    return @allreturn;
        
};

$AMI_Event_Handler{'holdreport'}{'DIAL'} = sub {
    my $event = shift;
    my @allreturn;

    if(${$event}{'SubEvent'} eq "Begin") {
        my $canal = FOP2::utils::get_channel(${$event}{'Channel'});
        my $desti = '';
        my $chan = '';

        if(defined($track{$canal})) {
            if(defined(${$event}{'DestChannel'})) {
                $chan = ${$event}{'DestChannel'}
            } else {
                $chan = ${$event}{'Destination'}
            }
            $desti = FOP2::utils::get_channel($chan);
            $queuechan{$desti}=$canal;
        }
    }
    return @allreturn;
};

$AMI_Event_Handler{'holdreport'}{'AGENTCONNECT'} = sub {
    my $event = shift;
    my @allreturn;
    my $chan='';

    if(defined(${$event}{'DestChannel'})) {
        $chan=${$event}{'DestChannel'};
    } else {
        $chan=${$event}{'Channel'};
    }

    my $canal = FOP2::utils::get_channel($chan);

    $membername{$canal}   = ${$event}{'MemberName'};
    $callunique{$canal}   = ${$event}{'Uniqueid'};
    $connectqueue{$canal} = ${$event}{'Queue'};

    if(!defined($queuechan{$canal})) { 
        $queuechan{$canal}=$canal; 
    } 
    return @allreturn;
};

$AMI_Event_Handler{'holdreport'}{'HANGUP'} = sub {
    my $event = shift;
    my @allreturn;

    my $canal = FOP2::utils::get_channel(${$event}{'Channel'});

    if(defined($ishold{$canal})) {
        if($ishold{$canal}==1) {
            my $name = $membername{$queuechan{$canal}};
            my $uniq = $callunique{$queuechan{$canal}};
            my $queue = $connectqueue{$queuechan{$canal}};

            $return  = "Action: QueueLog\r\n";
            $return .= "Queue: $queue\r\n";
            $return .= "Event: UNPAUSE\r\n";
            $return .= "Uniqueid: $uniq\r\n";
            $return .= "Message: Hold\r\n";
            $return .= "Interface: $name\r\n\r\n";
            push @allreturn, $return;

        }
    }

    delete $track{$canal};
    delete $queuechan{$canal};
    delete $membername{$canal};
    delete $callunique{$canal};
    delete $connectqueue{$canal};
    delete $ishold{$canal};
    return @allreturn;
};
